class ThargCmd
{
	constructor(all_targets, scheme, cycle, mdata)
	{
		this.i = 0;
		this.n = 5;
		this.all_targets = all_targets;
		this.scheme = scheme;
		this.cycle_num = cycle;
		this.mdata = mdata;
	}
	
	log(obj)
	{
		// Can use console.log here to show test outputs emitted by the scheme
	}
	
	// Fork this command object
	// Useful for modifying the attack function and discovering what another scheme would do
	copy()
	{
		var cmd = new ThargCmd(this.all_targets, this.scheme, this.cycle, this.mdata);
		cmd.n = this.n;
		return cmd;
	}
	
	cycle() {return this.cycle_num;}
	maelstrom() {return this.mdata.name;}
	controls() {return this.mdata.controls;}
	radius() {return this.mdata.radius;}
	targets() {return this.all_targets;}
	remaining() {return this.n;}
	
	// Perform one attack given the full listing entry
	// Returns true if this was the last attack for this maelstrom
	attack(tgt)
	{
		tgt.a.used = tgt.b.used = true;
		this.i += 1;
		tgt.a.mark.push({"s":this.scheme,"n":this.i});
		tgt.b.mark.push({"s":this.scheme,"n":this.i});
		return (this.n-=1) < 1;
	}
	
	// Check whether more attacks are available
	more() {return this.n >= 1;}
	nomore() {return this.n < 1;}
	// Expend an attack
	miss() {return (this.n-=1) < 1;}
	// Restore an attack
	unmiss() {this.n += 1;}
	
}
